std::basic_string::end,(3)

NAME
std::basic_string::end, - std::basic_string::end,

Synopsis
   iterator end(); (until C++11)
   iterator end() noexcept; (since C++11)
                        (until C++20)
   constexpr iterator end() noexcept; (since C++20)
   const_iterator end() const; (until C++11)
   const_iterator end() const (since C++11)
   noexcept; (1) (until C++20)
   constexpr const_iterator end() (since C++20)
   const noexcept; (2)
   const_iterator cend() const (since C++11)
   noexcept; (3) (until C++20)
   constexpr const_iterator cend() (since C++20)
   const noexcept;
   Returns an iterator to the character following the last character of the string.
   This character acts as a placeholder, attempting to access it results in undefined
   behavior.
   range-begin-end.svg

Parameters
   (none)

Return value
   iterator to the character following the last character

Complexity
   Constant

Example
// Run this code
 #include <iostream>
 #include <algorithm>
 #include <iterator>
 #include <string>
 int main()
 {
     std::string s("Exemparl");
     std::next_permutation(s.begin(), s.end());
     std::string c;
     std::copy(s.cbegin(), s.cend(), std::back_inserter(c));
     std::cout << c <<'\n'; // "Exemplar"
 }

Output:
 Exemplar

See also
   begin returns an iterator to the beginning
   cbegin (public member function)
   (C++11)
   end returns an iterator to the end
   cend (public member function of std::basic_string_view<CharT,Traits>)
   (C++17)